import pygame

class Keyboard:

    def __init__(self):
        self.key_up = 'up'
        self.key_down = 'down'
        self.key_left = 'left'
        self.key_right = 'right'
        self.key_quit = 'escape'
        self.key_enter = 'return'
        
        # set keyboard to repeat correctly
        pygame.key.set_repeat(40,40)

    def _key_index(self,keys):

        keylist = []
        for index,key in enumerate(keys):
            if key != 0:
                keylist.append(index)

        # return list of keys correctly mapped to a name
        return [ pygame.key.name(key) for key in keylist ]

    def poll(self):
        # user presses keyboard arrow controls
        # multiple key presses

        #get keys pressed array
        keys = self._key_index(pygame.key.get_pressed())
        
        # modified this function to not directly interact with game object
        # partially so that it could be used in the menu
        retval = ""
        if self.key_up in keys:
            retval += "u"
        if self.key_down in keys:
            retval += "d"
        if self.key_left in keys:
            retval += "l"
        if self.key_right in keys:
            retval += "r"
        if self.key_quit in keys:
            retval += "q"
        if self.key_enter in keys:
            retval += "e"
        return retval
        
