import pygame

import game
import menu
import keyboard
import mouse

'''
  This is the runnable class of the game, and loads everything else.

'''
class Main:
    
    def __init__(self):

        # Init pygame modules
        pygame.init()

        # Initialize the pygame clock
        self.clock = pygame.time.Clock()

        # Initialize input methods
        self.keyboard = keyboard.Keyboard()
        self.mouse = mouse.Mouse()
        
        # load assets
        # Game: data model of game
        self.game = game.Game()

        # Start game
        self.loop()

        # Quitting game, deinit stuff
        pygame.quit()


    def loop(self):

        # Show menu and allow player to choose start options
        pass
        
        # Start main game loop
        self.game.running = True
        while self.game.running:
            
            # Check for QUIT event and quit if running=False
            for event in pygame.event.get():
                if event.type == pygame.QUIT:
                    self.game.running = False

            # poll keyboard and mouse, return (kbd,(mleft,mright,(coordx,coordy)))
            # Move the player
            input = self.keyboard.poll(),self.mouse.poll() #pack these in one variable
            if input[0].count("q"): # if there's a q, that means ESC was pressed
                self.game.running = False
                
            # Move the computer and other objects
            self.game.tick(input)
            
            # Sleep until next cycle 
            self.clock.tick(60)


if __name__=='__main__':
    m = Main()
