import pygame
import os
import data
import powerup

class Menu:
    def __init__(self,game,clock,kbd,mouse,view):
        self.game = game
        self.background = self.game.resource['menu_bg']
        self.keyboard = kbd
        self.mouse = mouse
        self.view = view
        self.clock = clock
        
        self.title_font = pygame.font.Font(None,160)
        self.subtext_font = pygame.font.Font(None,32)
        self.menu_object = powerup.Powerup(game,(self.view.width,self.view.ctr[1]))

        self.choice = 0
        
    def display_menu(self,display):
        # Show a menu and animate for the user
        
        # Start main menu loop
        self.running = True
        while self.running:
            
            # Check for QUIT event and quit if running=False
            for event in pygame.event.get():
                if event.type == pygame.QUIT:
                    self.running = False

            # poll keyboard for arrow keys or ESC
            # Move the player
            input = self.keyboard.poll(),self.mouse.poll() #pack these in one variable
            if input[0].count("q"): # if there's a q, that means ESC was pressed
                self.running = False
                return 'q'
            elif input[0].count("e"): # if there's an e, that means Enter was pressed
                self.running = False
            if input[1][0]: # left mouse button was clicked
                self.running = False
                #print input[1][2]
                
            # Update the visible screen
            self.update()
            
            # Sleep until next cycle 
            self.clock.tick(60)


    def update(self):
        scr = self.view.screen
        scr.blit(self.background,(0,0))

        ctrx= scr.get_width()/2
        ctry= scr.get_height()/2
        
        text = self.title_font.render("ACW Mutate!",1,(0,0,0))
        scr.blit(text,(ctrx-text.get_width()/2,150))

        text = self.subtext_font.render("A game created for pyweek 13 (September 10, 2011)",1,(255,255,0))
        scr.blit(text,(ctrx-text.get_width()/2,400))

        text = self.subtext_font.render("Press Enter Key to continue or Esc to quit",1,(0,0,100))
        scr.blit(text,(ctrx-text.get_width()/2,550))



        pygame.display.flip() #show it all
