import pygame

class Mutation():
    def __init__(self,game,choices):
        self.game = game
        self.choices = choices
   
        self.bg = pygame.Surface((self.game.view.width,self.game.view.height),1).convert()
        self.bg.fill((255,255,255))
        self.alpha = 0
        self.choice = 0
        self.keydown = False
        self.prevkey = False
        self.cx = 400 #800/2
        self.cy = 300 #600/2
        
        self.subtext_font = pygame.font.Font(None,32)
        self.mutation_text = self.subtext_font.render( \
            "Mutate!  Choose the creature you will mutate into for next round",1,(255,0,0))
        self.mutation_text_attack = self.subtext_font.render( \
            choices[0]+": Attack",1,(255,0,0))
        self.mutation_text_defense = self.subtext_font.render( \
            choices[1]+": Defense",1,(0,0,255))
        self.mutation_text_speed = self.subtext_font.render( \
            choices[2]+": Speed",1,(0,255,0))
        self.mutation_text1 = self.subtext_font.render( \
            "Press Enter to choose.",1,(255,0,0))

    def tick(self,input):
        self.prevkey = self.keydown
        if input[0].count("l"):
            self.keydown = True
            if self.keydown!=self.prevkey:
                self.choice = ((self.choice-1)%3)
        elif input[0].count("r"):
            self.keydown = True
            if self.keydown!=self.prevkey:
                self.choice = ((self.choice+1)%3)
        elif input[0].count("e"):
            self.game.mutation_choice(self.choices[self.choice])
        else:
            self.keydown = False


    def update(self):
        scr = self.game.view.screen

        self.bg.set_alpha(self.alpha)
        if self.alpha < 255:
            self.alpha += 15
        
        # Display background
        scr.blit(self.bg,(0,0))
        
        # Display characters to choose from
        c = 0
        for i in self.choices:
            scr.blit(self.game.resource["ch_"+i],(c*225+75,75))
            c += 1

        # Display choice rectangle
        chrect = pygame.Rect((self.choice*225+75,75),(200,450))
        pygame.draw.rect(scr,(255,0,0),chrect,2)
            
        # Display text
        scr.blit(self.mutation_text, \
            (self.cx-self.mutation_text.get_width()/2,50))
        scr.blit(self.mutation_text1, \
            (self.cx-self.mutation_text1.get_width()/2,550))

        scr.blit(self.mutation_text_attack, \
            (175-(self.mutation_text_attack.get_width()/2),440))
        scr.blit(self.mutation_text_defense, \
            (400-(self.mutation_text_defense.get_width()/2),440))
        scr.blit(self.mutation_text_speed, \
            (625-(self.mutation_text_speed.get_width()/2),440))
