import random
import pygame
import gameobject
import math

class Player(gameobject.GameObject):
    def __init__(self,game,starting_position):
        gameobject.GameObject.__init__(self,game,starting_position) # superclass constructor

        self.xmove = 2 # movement rate per tick
        self.ymove = 2

        self.last_keypress = 0
        self.keypress = 0

    # This function override allows the player to appear to be standing in 3d on the square
    def getrect(self):
        if self.game.level==1:
            return pygame.Rect(self.x+10,self.y+10,self.image.get_width()-20,self.image.get_height()-20)
        else:
            return pygame.Rect(self.x,self.y,self.image.get_width(),self.image.get_height())


    def move(self,input,level=0):
        self.apply_physics()

        # the keyup-keypress stuff is logic to detect when
        # the user presses and releases a key
        self.last_keypress = self.keypress
        self.keypress = 0
       
        self.keyup_x = 0
        self.keyup_y = 0

        if input[0].count("u"):
            if level==1 or level==4:
                self.keypress += 1
                self.keyup_y = -1
            else:
                self.move_up()
        elif input[0].count("d"):
            if level==1 or level==4:
                self.keypress += 1
                self.keyup_y = 1
            else:
                self.move_down()
        if input[0].count("l"):
            if level==1 or level==4:
                self.keypress += 1
                self.keyup_x = -1
            else:
                self.move_left()
        elif input[0].count("r"):
            if level==1 or level==4:
                self.keypress += 1
                self.keyup_x = 1
            else:
                self.move_right()
        
        if input[1]:
            pass
            #print input[1][2] #coordinates
       
        if (level==1 or level==4) and self.keypress and not \
                self.keypress==self.last_keypress:
            self.vy += self.keyup_y
            if self.vy < -self.speed/8: self.vy = -self.speed/8
            if self.vy > self.speed/8: self.vy = self.speed/8
            self.vx += self.keyup_x
            if self.vx < -self.speed/8: self.vx = -self.speed/8
            if self.vx > self.speed/8: self.vx = self.speed/8
            

    def gather__find_closest_powerup(self):
        closest_powerup = self.game.map.width*self.game.map.height #start with a really far distance away
        x_dir = 0
        y_dir = 0
        for i in self.game.gameobjects:
            if i==self.game.player or i==self.game.computer: continue
            temp_x,temp_y = self.game.map.find_fastest_direct_path((self.cx,self.cy), (i.cx,i.cy))
            temp_dist = self.game.map.find_distance(0,0,temp_x,temp_y)
            if temp_dist<closest_powerup:
                closest_powerup=temp_dist
                x_dir = temp_x
                y_dir = temp_y
        return x_dir,y_dir
