import pygame
import gameobject
import random

# to be defined:
# What sorts of powerups are there?
# moving, stationary?
# how much power do they provide?
# do they hurt you?
class Powerup(gameobject.GameObject):
    def __init__(self,game,starting_position):
        gameobject.GameObject.__init__(self,game,starting_position) # superclass constructor

        # image load
        stats = ["attack","defense","speed"]
        self.stat = stats[random.randint(0,2)]

        if self.stat == "speed":
            self.image_normal = self.game.resource['speed_powerup_normal']
            self.image_up = self.game.resource['speed_powerup_up']
            self.image_down = self.game.resource['speed_powerup_down']
        elif self.stat == "attack":
            self.image_normal = self.game.resource['attack_powerup_normal']
            self.image_up = self.game.resource['attack_powerup_up']
            self.image_down = self.game.resource['attack_powerup_down']
        else:
            self.image_normal = self.game.resource['defense_powerup_normal']
            self.image_up = self.game.resource['defense_powerup_up']
            self.image_down = self.game.resource['defense_powerup_down']

        self.image = self.image_normal
        self.images = [self.image_normal,self.image_up,self.image_normal,self.image_down]

        self.xmove = 1 #movement rate per tick
        self.ymove = 1

        self.animation_counter = 0
        self.animation_index = random.randint(0,4)
        self.animation_speed = random.randint(10,15)

        
        
    def move(self):
        # this function is run once every game loop to move this powerup
        self.apply_physics()
        self.animation_counter = (self.animation_counter + 1) % self.animation_speed
        if self.animation_counter==0:
            self.animation_index = (self.animation_index + 1) % len(self.images)
            self.image = self.images[self.animation_index]
            if self.animation_index==1 or self.animation_index==2:
                self.move_down(2)
            else:
                self.move_up(2)
                

                
                
                
                
                
                
